=== debian/changelog ===
ros-melodic-tsid (1.4.2-1stretch) stretch; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Guilhem Saurel <guilhem.saurel@laas.fr>  Fri, 27 Nov 2020 09:56:45 -0000
