=== debian/changelog ===
ros-melodic-tsid (1.6.2-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Guilhem Saurel <guilhem.saurel@laas.fr>  Tue, 04 Oct 2022 08:44:15 -0000
