=== debian/control ===
Source: ros-melodic-tsid
Section: misc
Priority: optional
Maintainer: Guilhem Saurel <guilhem.saurel@laas.fr>
Build-Depends: debhelper (>= 9.0.0), cmake, doxygen, git, graphviz, libboost-all-dev, ros-melodic-eigenpy, ros-melodic-eiquadprog, ros-melodic-pinocchio
Homepage: https://github.com/stack-of-tasks/tsid
Standards-Version: 3.9.2

Package: ros-melodic-tsid
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, graphviz, libboost-all-dev, ros-melodic-catkin, ros-melodic-eigenpy, ros-melodic-eiquadprog, ros-melodic-pinocchio
Description: Efficient Task Space Inverse Dynamics (TSID) based on Pinocchio
